<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.10.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>MeLOn: C:/Data/Git/MeLOn/common/inc/MeLOn.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<script type="text/javascript" src="clipboard.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript" src="cookie.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="MeLOn_only.png"/></td>
  <td id="projectalign">
   <div id="projectname">MeLOn
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.10.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() { codefold.init(0); });
/* @license-end */
</script>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function(){initNavTree('_me_l_on_8h_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="headertitle"><div class="title">MeLOn.h</div></div>
</div><!--header-->
<div class="contents">
<a href="_me_l_on_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/**********************************************************************************</span></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment">* Copyright (c) 2020 Process Systems Engineering (AVT.SVT), RWTH Aachen University</span></div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment">*</span></div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment">* This program and the accompanying materials are made available under the</span></div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="comment">* terms of the Eclipse Public License 2.0 which is available at</span></div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="comment">* http://www.eclipse.org/legal/epl-2.0.</span></div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span><span class="comment">*</span></div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span><span class="comment">* SPDX-License-Identifier: EPL-2.0</span></div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span><span class="comment">*</span></div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span><span class="comment">* @file MeLOn.h</span></div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span><span class="comment">*</span></div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span><span class="comment">* @brief File containing declaration of the MelonModel class.</span></div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span><span class="comment">*</span></div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span><span class="comment">**********************************************************************************/</span></div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span> </div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span><span class="preprocessor">#pragma once</span></div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span> </div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span><span class="preprocessor">#include &lt;memory&gt;</span>   <span class="comment">// std::shared_ptr, std::unique_ptr</span></div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span><span class="preprocessor">#include &lt;vector&gt;</span>   <span class="comment">// std::vector</span></div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span> </div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span><span class="preprocessor">#include &quot;<a class="code" href="model_parser_8h.html">modelParser.h</a>&quot;</span></div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span><span class="preprocessor">#include &quot;<a class="code" href="model_data_8h.html">modelData.h</a>&quot;</span></div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span><span class="preprocessor">#include &quot;<a class="code" href="exceptions_8h.html">exceptions.h</a>&quot;</span></div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span> </div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span><span class="keyword">namespace </span><a class="code hl_namespace" href="namespacemelon.html">melon</a> {</div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span> </div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span>    <span class="comment">/*</span></div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span><span class="comment">    * @class MelonModel</span></div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno">   29</span><span class="comment">    * @brief This class is a abstract parent class for models implemented in the MeLOn library</span></div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span><span class="comment">    */</span></div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span>    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;</div>
<div class="foldopen" id="foldopen00032" data-start="{" data-end="};">
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno"><a class="line" href="classmelon_1_1_melon_model.html">   32</a></span>    <span class="keyword">class </span><a class="code hl_class" href="classmelon_1_1_melon_model.html">MelonModel</a> {</div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span>    <span class="keyword">public</span>:</div>
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno"><a class="line" href="classmelon_1_1_melon_model.html#a1c7f4a28d7a34e48a93b9899a66204b0">   37</a></span>        <span class="keyword">virtual</span> <a class="code hl_function" href="classmelon_1_1_melon_model.html#a1c7f4a28d7a34e48a93b9899a66204b0">~MelonModel</a>() = <span class="keywordflow">default</span>;</div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno">   38</span> </div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno">   46</span>        <span class="keywordtype">void</span> <a class="code hl_function" href="classmelon_1_1_melon_model.html#a9acb78ea183bc6bf583540efcef58a0b">load_model</a>(std::string modelName, <a class="code hl_enumeration" href="namespacemelon.html#a4304be33fc99f22bd328db5774394531">MODEL_FILE_TYPE</a> fileType);</div>
<div class="line"><a id="l00047" name="l00047"></a><span class="lineno">   47</span> </div>
<div class="line"><a id="l00057" name="l00057"></a><span class="lineno">   57</span>        <span class="keywordtype">void</span> <a class="code hl_function" href="classmelon_1_1_melon_model.html#a9acb78ea183bc6bf583540efcef58a0b">load_model</a>(std::string modelPath, std::string modelName, <a class="code hl_enumeration" href="namespacemelon.html#a4304be33fc99f22bd328db5774394531">MODEL_FILE_TYPE</a> fileType);</div>
<div class="line"><a id="l00058" name="l00058"></a><span class="lineno">   58</span> </div>
<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span>        <span class="keywordtype">void</span> <a class="code hl_function" href="classmelon_1_1_melon_model.html#a9acb78ea183bc6bf583540efcef58a0b">load_model</a>(std::shared_ptr&lt;const ModelData&gt; modelData);</div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span> </div>
<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span>    <span class="keyword">protected</span>:</div>
<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span> </div>
<div class="line"><a id="l00068" name="l00068"></a><span class="lineno"><a class="line" href="classmelon_1_1_melon_model.html#a17ac3b399c0615c5e4033f532e8cc7c4">   68</a></span>        <span class="keywordtype">bool</span> <a class="code hl_variable" href="classmelon_1_1_melon_model.html#a17ac3b399c0615c5e4033f532e8cc7c4">_modelLoaded</a> { <span class="keyword">false</span> };                            </div>
<div class="line"><a id="l00069" name="l00069"></a><span class="lineno"><a class="line" href="classmelon_1_1_melon_model.html#a79a4a98914ebfc91398a20b9014726e1">   69</a></span>        std::shared_ptr&lt;ModelParserFactory&gt; <a class="code hl_variable" href="classmelon_1_1_melon_model.html#a79a4a98914ebfc91398a20b9014726e1">_parserFactory</a>;     </div>
<div class="line"><a id="l00076" name="l00076"></a><span class="lineno"><a class="line" href="classmelon_1_1_melon_model.html#a0877da878cabba96d129b5e2540b9eca">   76</a></span>        <a class="code hl_function" href="classmelon_1_1_melon_model.html#a0877da878cabba96d129b5e2540b9eca">MelonModel</a>(std::shared_ptr&lt;ModelParserFactory&gt; parserFactory) : <a class="code hl_variable" href="classmelon_1_1_melon_model.html#a79a4a98914ebfc91398a20b9014726e1">_parserFactory</a>(parserFactory) {};</div>
<div class="line"><a id="l00077" name="l00077"></a><span class="lineno">   77</span> </div>
<div class="line"><a id="l00083" name="l00083"></a><span class="lineno"><a class="line" href="classmelon_1_1_melon_model.html#ae1d72d9bbe5993be3d9230395abc0310">   83</a></span>        <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code hl_function" href="classmelon_1_1_melon_model.html#ae1d72d9bbe5993be3d9230395abc0310">_set_data_object</a>(std::shared_ptr&lt;const ModelData&gt; modelData) = 0;</div>
<div class="line"><a id="l00084" name="l00084"></a><span class="lineno">   84</span>        </div>
<div class="line"><a id="l00094" name="l00094"></a><span class="lineno">   94</span>        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> RandomAccessIterator&gt;</div>
<div class="line"><a id="l00095" name="l00095"></a><span class="lineno">   95</span>        <span class="keywordtype">void</span> <a class="code hl_function" href="classmelon_1_1_melon_model.html#ab783bd628a80774149c34f0e2b8f8f48">_set_constraints</a>(std::vector&lt;T&gt;&amp; constraints, std::vector&lt;T&gt;&amp; constraintEvaluation, RandomAccessIterator&amp; constraintValue) <span class="keyword">const</span>;</div>
<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span> </div>
<div class="line"><a id="l00106" name="l00106"></a><span class="lineno">  106</span>        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> RandomAccessIterator&gt;</div>
<div class="line"><a id="l00107" name="l00107"></a><span class="lineno">  107</span>        <span class="keywordtype">void</span> <a class="code hl_function" href="classmelon_1_1_melon_model.html#ab783bd628a80774149c34f0e2b8f8f48">_set_constraints</a>(std::vector&lt;T&gt;&amp; constraints, T&amp; constraintEvaluation, RandomAccessIterator&amp; constraintValue) <span class="keyword">const</span>;</div>
<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span>    };</div>
</div>
<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span> </div>
<div class="line"><a id="l00110" name="l00110"></a><span class="lineno">  110</span> </div>
<div class="line"><a id="l00112" name="l00112"></a><span class="lineno">  112</span>    <span class="comment">// Function wich loads model from file modelName</span></div>
<div class="line"><a id="l00113" name="l00113"></a><span class="lineno">  113</span>    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="foldopen" id="foldopen00114" data-start="{" data-end="}">
<div class="line"><a id="l00114" name="l00114"></a><span class="lineno"><a class="line" href="classmelon_1_1_melon_model.html#a9acb78ea183bc6bf583540efcef58a0b">  114</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="classmelon_1_1_melon_model.html#a9acb78ea183bc6bf583540efcef58a0b">MelonModel&lt;T&gt;::load_model</a>(std::string modelName, <a class="code hl_enumeration" href="namespacemelon.html#a4304be33fc99f22bd328db5774394531">MODEL_FILE_TYPE</a> fileType) {</div>
<div class="line"><a id="l00115" name="l00115"></a><span class="lineno">  115</span>        load_model(<span class="stringliteral">&quot;&quot;</span>, modelName, fileType);</div>
<div class="line"><a id="l00116" name="l00116"></a><span class="lineno">  116</span>    }</div>
</div>
<div class="line"><a id="l00117" name="l00117"></a><span class="lineno">  117</span> </div>
<div class="line"><a id="l00118" name="l00118"></a><span class="lineno">  118</span> </div>
<div class="line"><a id="l00120" name="l00120"></a><span class="lineno">  120</span>    <span class="comment">// Constructor which loads model from file &quot;modelName&quot; located in &quot;filePat&quot;h</span></div>
<div class="line"><a id="l00121" name="l00121"></a><span class="lineno">  121</span>    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="foldopen" id="foldopen00122" data-start="{" data-end="}">
<div class="line"><a id="l00122" name="l00122"></a><span class="lineno"><a class="line" href="classmelon_1_1_melon_model.html#ae002de8e7c020adfcad49ce7e050066e">  122</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="classmelon_1_1_melon_model.html#a9acb78ea183bc6bf583540efcef58a0b">MelonModel&lt;T&gt;::load_model</a>(std::string modelPath, std::string modelName, <a class="code hl_enumeration" href="namespacemelon.html#a4304be33fc99f22bd328db5774394531">MODEL_FILE_TYPE</a> fileType) {</div>
<div class="line"><a id="l00123" name="l00123"></a><span class="lineno">  123</span> </div>
<div class="line"><a id="l00124" name="l00124"></a><span class="lineno">  124</span>        std::shared_ptr&lt;ModelData&gt; modelData;</div>
<div class="line"><a id="l00125" name="l00125"></a><span class="lineno">  125</span> </div>
<div class="line"><a id="l00126" name="l00126"></a><span class="lineno">  126</span>        <span class="keywordflow">try</span> {</div>
<div class="line"><a id="l00127" name="l00127"></a><span class="lineno">  127</span>            std::unique_ptr&lt;ModelParser&gt; parser = _parserFactory-&gt;create_model_parser(fileType);</div>
<div class="line"><a id="l00128" name="l00128"></a><span class="lineno">  128</span>            modelData = parser-&gt;parse_model(modelPath, modelName);</div>
<div class="line"><a id="l00129" name="l00129"></a><span class="lineno">  129</span>            _set_data_object(modelData);</div>
<div class="line"><a id="l00130" name="l00130"></a><span class="lineno">  130</span>        }</div>
<div class="line"><a id="l00131" name="l00131"></a><span class="lineno">  131</span>        <span class="keywordflow">catch</span> (<span class="keyword">const</span> std::exception&amp; e) {</div>
<div class="line"><a id="l00132" name="l00132"></a><span class="lineno">  132</span>            <span class="keywordflow">throw</span>(<a class="code hl_class" href="class_melon_exception.html">MelonException</a>(<span class="stringliteral">&quot;  Encountered a fatal error while loading model from file. Terminating.&quot;</span>, e));</div>
<div class="line"><a id="l00133" name="l00133"></a><span class="lineno">  133</span>        }</div>
<div class="line"><a id="l00134" name="l00134"></a><span class="lineno">  134</span>        <span class="keywordflow">catch</span> (...) {</div>
<div class="line"><a id="l00135" name="l00135"></a><span class="lineno">  135</span>            <span class="keywordflow">throw</span>(<a class="code hl_class" href="class_melon_exception.html">MelonException</a>(<span class="stringliteral">&quot;  Encountered a fatal error while loading model from file. Terminating.&quot;</span>));</div>
<div class="line"><a id="l00136" name="l00136"></a><span class="lineno">  136</span>        }</div>
<div class="line"><a id="l00137" name="l00137"></a><span class="lineno">  137</span> </div>
<div class="line"><a id="l00138" name="l00138"></a><span class="lineno">  138</span>        _modelLoaded = <span class="keyword">true</span>;</div>
<div class="line"><a id="l00139" name="l00139"></a><span class="lineno">  139</span> </div>
<div class="line"><a id="l00140" name="l00140"></a><span class="lineno">  140</span>    }</div>
</div>
<div class="line"><a id="l00141" name="l00141"></a><span class="lineno">  141</span> </div>
<div class="line"><a id="l00142" name="l00142"></a><span class="lineno">  142</span> </div>
<div class="line"><a id="l00144" name="l00144"></a><span class="lineno">  144</span>    <span class="comment">// Constructor which loads model from ModelData object</span></div>
<div class="line"><a id="l00145" name="l00145"></a><span class="lineno">  145</span>    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="foldopen" id="foldopen00146" data-start="{" data-end="}">
<div class="line"><a id="l00146" name="l00146"></a><span class="lineno"><a class="line" href="classmelon_1_1_melon_model.html#a37fb378f8eabbcfdb7db707dbfa04a26">  146</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="classmelon_1_1_melon_model.html#a9acb78ea183bc6bf583540efcef58a0b">MelonModel&lt;T&gt;::load_model</a>(std::shared_ptr&lt;const ModelData&gt; modelData) {</div>
<div class="line"><a id="l00147" name="l00147"></a><span class="lineno">  147</span>        </div>
<div class="line"><a id="l00148" name="l00148"></a><span class="lineno">  148</span>        <span class="keywordflow">try</span> {</div>
<div class="line"><a id="l00149" name="l00149"></a><span class="lineno">  149</span>            _set_data_object(modelData);</div>
<div class="line"><a id="l00150" name="l00150"></a><span class="lineno">  150</span>        }</div>
<div class="line"><a id="l00151" name="l00151"></a><span class="lineno">  151</span>        <span class="keywordflow">catch</span> (std::exception &amp;e) {</div>
<div class="line"><a id="l00152" name="l00152"></a><span class="lineno">  152</span>            <span class="keywordflow">throw</span>(<a class="code hl_class" href="class_melon_exception.html">MelonException</a>(<span class="stringliteral">&quot;  Encountered a fatal error while loading model from data object. Terminating.&quot;</span>, e));</div>
<div class="line"><a id="l00153" name="l00153"></a><span class="lineno">  153</span>        }</div>
<div class="line"><a id="l00154" name="l00154"></a><span class="lineno">  154</span>        <span class="keywordflow">catch</span> (...) {</div>
<div class="line"><a id="l00155" name="l00155"></a><span class="lineno">  155</span>            <span class="keywordflow">throw</span>(<a class="code hl_class" href="class_melon_exception.html">MelonException</a>(<span class="stringliteral">&quot;  Encountered a fatal error while loading model from data object. Terminating.&quot;</span>));</div>
<div class="line"><a id="l00156" name="l00156"></a><span class="lineno">  156</span>        }</div>
<div class="line"><a id="l00157" name="l00157"></a><span class="lineno">  157</span> </div>
<div class="line"><a id="l00158" name="l00158"></a><span class="lineno">  158</span>        _modelLoaded = <span class="keyword">true</span>;</div>
<div class="line"><a id="l00159" name="l00159"></a><span class="lineno">  159</span>    }</div>
</div>
<div class="line"><a id="l00160" name="l00160"></a><span class="lineno">  160</span> </div>
<div class="line"><a id="l00162" name="l00162"></a><span class="lineno">  162</span>    <span class="comment">// Sets constraints required for fullspace opimization</span></div>
<div class="line"><a id="l00163" name="l00163"></a><span class="lineno">  163</span>    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a id="l00164" name="l00164"></a><span class="lineno">  164</span>    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> RandomAccessIterator&gt;</div>
<div class="foldopen" id="foldopen00165" data-start="{" data-end="}">
<div class="line"><a id="l00165" name="l00165"></a><span class="lineno"><a class="line" href="classmelon_1_1_melon_model.html#ab783bd628a80774149c34f0e2b8f8f48">  165</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="classmelon_1_1_melon_model.html#ab783bd628a80774149c34f0e2b8f8f48">MelonModel&lt;T&gt;::_set_constraints</a>(std::vector&lt;T&gt;&amp; constraints, std::vector&lt;T&gt;&amp; constraintEvaluation, RandomAccessIterator&amp; constraintValue)<span class="keyword"> const </span>{</div>
<div class="line"><a id="l00166" name="l00166"></a><span class="lineno">  166</span>        <span class="keywordflow">for</span> (<span class="keyword">auto</span>&amp; i : constraintEvaluation) {</div>
<div class="line"><a id="l00167" name="l00167"></a><span class="lineno">  167</span>            _set_constraints(constraints, i, constraintValue);</div>
<div class="line"><a id="l00168" name="l00168"></a><span class="lineno">  168</span>        }</div>
<div class="line"><a id="l00169" name="l00169"></a><span class="lineno">  169</span>    }</div>
</div>
<div class="line"><a id="l00170" name="l00170"></a><span class="lineno">  170</span> </div>
<div class="line"><a id="l00171" name="l00171"></a><span class="lineno">  171</span> </div>
<div class="line"><a id="l00173" name="l00173"></a><span class="lineno">  173</span>    <span class="comment">// Sets constraints required for fullspace opimization</span></div>
<div class="line"><a id="l00174" name="l00174"></a><span class="lineno">  174</span>    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a id="l00175" name="l00175"></a><span class="lineno">  175</span>    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> RandomAccessIterator&gt;</div>
<div class="foldopen" id="foldopen00176" data-start="{" data-end="}">
<div class="line"><a id="l00176" name="l00176"></a><span class="lineno"><a class="line" href="classmelon_1_1_melon_model.html#a7b1045b2b3c48d7e89042abbf042184e">  176</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="classmelon_1_1_melon_model.html#ab783bd628a80774149c34f0e2b8f8f48">MelonModel&lt;T&gt;::_set_constraints</a>(std::vector&lt;T&gt;&amp; constraints, T&amp; constraintEvaluation, RandomAccessIterator&amp; constraintValue)<span class="keyword"> const </span>{</div>
<div class="line"><a id="l00177" name="l00177"></a><span class="lineno">  177</span>        T cv = *constraintValue;</div>
<div class="line"><a id="l00178" name="l00178"></a><span class="lineno">  178</span>        T constraint = constraintEvaluation - cv;</div>
<div class="line"><a id="l00179" name="l00179"></a><span class="lineno">  179</span>        constraints.push_back(constraint);</div>
<div class="line"><a id="l00180" name="l00180"></a><span class="lineno">  180</span> </div>
<div class="line"><a id="l00181" name="l00181"></a><span class="lineno">  181</span>        <span class="comment">// Set normalized Input to the value provided by the solver for further calculations</span></div>
<div class="line"><a id="l00182" name="l00182"></a><span class="lineno">  182</span>        constraintEvaluation = *constraintValue;</div>
<div class="line"><a id="l00183" name="l00183"></a><span class="lineno">  183</span>        constraintValue++;</div>
<div class="line"><a id="l00184" name="l00184"></a><span class="lineno">  184</span>    }</div>
</div>
<div class="line"><a id="l00185" name="l00185"></a><span class="lineno">  185</span> </div>
<div class="line"><a id="l00186" name="l00186"></a><span class="lineno">  186</span>}</div>
<div class="ttc" id="aclass_melon_exception_html"><div class="ttname"><a href="class_melon_exception.html">MelonException</a></div><div class="ttdoc">This class defines the exceptions thrown by FeedForwardNet.</div><div class="ttdef"><b>Definition</b> exceptions.h:32</div></div>
<div class="ttc" id="aclassmelon_1_1_melon_model_html"><div class="ttname"><a href="classmelon_1_1_melon_model.html">melon::MelonModel</a></div><div class="ttdef"><b>Definition</b> MeLOn.h:32</div></div>
<div class="ttc" id="aclassmelon_1_1_melon_model_html_a0877da878cabba96d129b5e2540b9eca"><div class="ttname"><a href="classmelon_1_1_melon_model.html#a0877da878cabba96d129b5e2540b9eca">melon::MelonModel::MelonModel</a></div><div class="ttdeci">MelonModel(std::shared_ptr&lt; ModelParserFactory &gt; parserFactory)</div><div class="ttdoc">Constructor.</div><div class="ttdef"><b>Definition</b> MeLOn.h:76</div></div>
<div class="ttc" id="aclassmelon_1_1_melon_model_html_a17ac3b399c0615c5e4033f532e8cc7c4"><div class="ttname"><a href="classmelon_1_1_melon_model.html#a17ac3b399c0615c5e4033f532e8cc7c4">melon::MelonModel::_modelLoaded</a></div><div class="ttdeci">bool _modelLoaded</div><div class="ttdef"><b>Definition</b> MeLOn.h:68</div></div>
<div class="ttc" id="aclassmelon_1_1_melon_model_html_a1c7f4a28d7a34e48a93b9899a66204b0"><div class="ttname"><a href="classmelon_1_1_melon_model.html#a1c7f4a28d7a34e48a93b9899a66204b0">melon::MelonModel::~MelonModel</a></div><div class="ttdeci">virtual ~MelonModel()=default</div><div class="ttdoc">Default destructor.</div></div>
<div class="ttc" id="aclassmelon_1_1_melon_model_html_a79a4a98914ebfc91398a20b9014726e1"><div class="ttname"><a href="classmelon_1_1_melon_model.html#a79a4a98914ebfc91398a20b9014726e1">melon::MelonModel::_parserFactory</a></div><div class="ttdeci">std::shared_ptr&lt; ModelParserFactory &gt; _parserFactory</div><div class="ttdef"><b>Definition</b> MeLOn.h:69</div></div>
<div class="ttc" id="aclassmelon_1_1_melon_model_html_a9acb78ea183bc6bf583540efcef58a0b"><div class="ttname"><a href="classmelon_1_1_melon_model.html#a9acb78ea183bc6bf583540efcef58a0b">melon::MelonModel::load_model</a></div><div class="ttdeci">void load_model(std::string modelName, MODEL_FILE_TYPE fileType)</div><div class="ttdoc">Loads new model from file.</div><div class="ttdef"><b>Definition</b> MeLOn.h:114</div></div>
<div class="ttc" id="aclassmelon_1_1_melon_model_html_ab783bd628a80774149c34f0e2b8f8f48"><div class="ttname"><a href="classmelon_1_1_melon_model.html#ab783bd628a80774149c34f0e2b8f8f48">melon::MelonModel::_set_constraints</a></div><div class="ttdeci">void _set_constraints(std::vector&lt; T &gt; &amp;constraints, std::vector&lt; T &gt; &amp;constraintEvaluation, RandomAccessIterator &amp;constraintValue) const</div><div class="ttdoc">Sets constraints required for fullspace opimization.</div><div class="ttdef"><b>Definition</b> MeLOn.h:165</div></div>
<div class="ttc" id="aclassmelon_1_1_melon_model_html_ae1d72d9bbe5993be3d9230395abc0310"><div class="ttname"><a href="classmelon_1_1_melon_model.html#ae1d72d9bbe5993be3d9230395abc0310">melon::MelonModel::_set_data_object</a></div><div class="ttdeci">virtual void _set_data_object(std::shared_ptr&lt; const ModelData &gt; modelData)=0</div><div class="ttdoc">Sets data object containing model parameters.</div></div>
<div class="ttc" id="aexceptions_8h_html"><div class="ttname"><a href="exceptions_8h.html">exceptions.h</a></div></div>
<div class="ttc" id="amodel_data_8h_html"><div class="ttname"><a href="model_data_8h.html">modelData.h</a></div></div>
<div class="ttc" id="amodel_parser_8h_html"><div class="ttname"><a href="model_parser_8h.html">modelParser.h</a></div></div>
<div class="ttc" id="anamespacemelon_html"><div class="ttname"><a href="namespacemelon.html">melon</a></div><div class="ttdef"><b>Definition</b> kernel.h:21</div></div>
<div class="ttc" id="anamespacemelon_html_a4304be33fc99f22bd328db5774394531"><div class="ttname"><a href="namespacemelon.html#a4304be33fc99f22bd328db5774394531">melon::MODEL_FILE_TYPE</a></div><div class="ttdeci">MODEL_FILE_TYPE</div><div class="ttdoc">Enum for representing the parsable filetypes.</div><div class="ttdef"><b>Definition</b> modelParser.h:30</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_bdd9a5d540de89e9fe90efdfc6973a4f.html">common</a></li><li class="navelem"><a class="el" href="dir_a065f42410ce59d310ee6ca453a28844.html">inc</a></li><li class="navelem"><a class="el" href="_me_l_on_8h.html">MeLOn.h</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.10.0 </li>
  </ul>
</div>
</body>
</html>
